/*
  This program tests your implentations of Evaluate.java,
  PrettyPrint.java, and AST2infix.java. When your implentations
  are correct, the output from this program should look exactly
  like the contents of the file output.txt.

  You should consider creating your own test expressions to make
  sure your implementations are correct.
*/

public class Tests
{
   public static void main(String[] args)
   {
      String[] exprs = {
                         "( + 2 ( * 5 5 ) ( / 4 2 ) )",
                         "( + ( - 10 ) ( + 10 ) )",
                         "( * ( + 2 3 ) ( + 4 5 ) ( + 5 7 ) )",
                         "( && ( ! ( > 1 2 ) ) ( == ( - ( - 2 4 ) ) 2 ) )",
                         "( || true ( != ( / 1 0 ) 0 ) )",
                         "( && ( == ( - 1 1 ) 0 ) ( < ( - 1 ) 1 ) false ( == 0 ( / 1 0 ) ) )",
                         "( + 1 ( ^ 2 1 ) ( ^ 2 2 ) ( ^ 2 3 ) ( ^ 2 4 ) ( ^ 2 5 ) ( ^ 2 6 ) )"
                       };

      for (int i = 0; i < exprs.length; i++)
      {
         Tree expr = BuildTree.buildTree( exprs[i] );

         System.out.println( exprs[i] + "\n" );
         System.out.println( AST2infix.ast2infix( expr ) + "\n" );
         System.out.println( PrettyPrinter.prettyPrint( expr ) + "\n" );

         Value value = Evaluate.evaluate( expr );

         System.out.println( value );
         System.out.println("========================================\n");
      }
   }//main

}//Tests
